#include <stdlib.h>
#include <windows.h>
#include "resource.h"
TCHAR tMaru[4], tTemp[128];
SYSTEM_POWER_STATUS_EX2 pSystemPowerStatusEx2;
int i, per, Vol, iTemp, ac, bf, KetaA, KetaB, KetaC;
HBITMAP hBitmap, hBmpMask, hBmpMaskAc, hWndBufferBMP;
HBRUSH whiteBrush;
HDC wDC, hHaikei, hNum, hWndBufferDC;
HMENU hMenu;
BOOL g_bWindowMoved;
POINT g_WindowDragPoint;
HRGN hMainRgn, hMainRgnAc;
SIZE WindowSize;

HRGN getRgnFromHBITMAP( HBITMAP hBMP, HWND hWnd );
void RefreshBuffer();
void DrawBuffer(HDC);
void DefaultPos(HWND);

HRGN getRgnFromHBITMAP( HBITMAP hBMP, HWND hWnd ) {
	BITMAP bi;
	GetObject( hBMP, sizeof(BITMAP), &bi );
	HRGN hRgn = CreateRectRgn( 0, 0, bi.bmWidth, bi.bmHeight );
	HDC hDC = GetDC( NULL );
	HDC memDC = CreateCompatibleDC( hDC );
	SelectObject( memDC, hBMP );
	int x, y;
	for( y=0; y<bi.bmHeight; y++ ) {
		for( x=0; x<bi.bmWidth; x++ ) {
			COLORREF color = GetPixel( memDC, x, y );
			if( color != 0x00000000 ) {
				HRGN DiffRgn = CreateRectRgn( x, y, x+1, y+1 );
				CombineRgn( hRgn, hRgn, DiffRgn, RGN_DIFF);
				DeleteObject( DiffRgn );
			}
		}
	}
	DeleteDC( memDC );
	ReleaseDC( hWnd, hDC );
	return hRgn;
}

void RefreshBuffer(){
	RECT WndBuffer_rc = { 0,0,WindowSize.cx,WindowSize.cy};
	FillRect(hWndBufferDC, &WndBuffer_rc, whiteBrush);
	if(ac){
		BitBlt(hWndBufferDC , 0 , 0 , 44 , 20 , hHaikei , 0 , 0 , SRCCOPY);
	}else{
		BitBlt(hWndBufferDC , 11 , 0 , 33 , 20 , hHaikei , 11 , 0 , SRCCOPY);
	}
	if(per == 100){
		BitBlt(hWndBufferDC , 17 , 5 , 24 , 11 , hNum , 77 , 0 , SRCCOPY);
	}else{
		BitBlt(hWndBufferDC , 18 , 5 , 7 , 11 , hNum , 7 * KetaA , 0 , SRCCOPY);
		BitBlt(hWndBufferDC , 26 , 5 , 7 , 11 , hNum , 7 * KetaB , 0 , SRCCOPY);
		BitBlt(hWndBufferDC , 34 , 5 , 7 , 11 , hNum , 70 , 0 , SRCCOPY);
	}
	SetROP2(hWndBufferDC, R2_MASKPEN);
	SelectObject(hWndBufferDC, GetStockObject(NULL_PEN));
	if(bf == 9){
		SelectObject(hWndBufferDC, CreateSolidBrush(RGB(0x00 , 0xFF , 0x00)));
	}else{
		if(per > 40){
			SelectObject(hWndBufferDC, CreateSolidBrush(RGB(0x66 , 0xCC , 0xFF)));
		}else if(per > 10){
			SelectObject(hWndBufferDC, CreateSolidBrush(RGB(0xFF , 0xCC , 0x00)));
		}else{
			SelectObject(hWndBufferDC, CreateSolidBrush(RGB(0xFF , 0x00 , 0x00)));
		}
	}
	Rectangle(hWndBufferDC, 41 - KetaC , 3 , 41 , 17);
}

void DrawBuffer(HDC hDC){
	BitBlt(hDC, 0, 0, WindowSize.cx, WindowSize.cy, hWndBufferDC, 0 , 0 , SRCCOPY);
}

void DefaultPos(HWND hWnd){
	SetWindowPos(hWnd, HWND_TOPMOST, GetSystemMetrics(SM_CXSCREEN) - 4 - WindowSize.cx, 4 , 0, 0, SWP_NOSIZE);
}

LRESULT CALLBACK WndProc(
	HWND hWnd, 
	UINT msg, 
	WPARAM wParam, 
	LPARAM lParam
){
	PAINTSTRUCT ps;
	switch(msg){
	case WM_PAINT:
		wDC = BeginPaint(hWnd , &ps);
		DrawBuffer(wDC);
		EndPaint(hWnd , &ps);
		break;
	case WM_TIMER:
		SetWindowPos(hWnd , HWND_TOPMOST , 0, 0 , 0, 0, SWP_NOSIZE | SWP_NOMOVE);
		GetSystemPowerStatusEx2(&pSystemPowerStatusEx2 ,128, 1);
		Vol = pSystemPowerStatusEx2.BatteryVoltage;
		ac = pSystemPowerStatusEx2.ACLineStatus;
		bf = pSystemPowerStatusEx2.BatteryFlag;
		if(ac) Vol -= 50;
		if(Vol > 4100){
			per = 100;
		}else if(Vol > 4050){
			per = Vol - 4050;
			per = (int)(per * 0.6);
			per = 70 + per;
		}else if(Vol > 3750){
			per = Vol - 3750;
			per = (int)(per / 10);
			per = 40 + per;
		}else if(Vol > 3450){
			per = Vol - 3450;
			per = (int)(per / 10);
			per = 10 + per;
		}else if(Vol > 3150){
			per = Vol - 3150;
			per = (int)(per / 30);
		}else{
			per = 0;
		}
		KetaB = per % 10;
		KetaA = per - KetaB;
		KetaA = KetaA / 10;
		KetaC = per % 4;
		KetaC = per - KetaC;
		KetaC = KetaC / 4;
		if(ac){
			HRGN hRgn = CreateRectRgn( 0, 0, 0, 0 );
			CombineRgn(hRgn, hRgn, hMainRgnAc, RGN_OR);
			SetWindowRgn(hWnd, hRgn, 1);
		}else{
			HRGN hRgn = CreateRectRgn( 0, 0, 0, 0 );
			CombineRgn(hRgn, hRgn, hMainRgn, RGN_OR);
			SetWindowRgn(hWnd, hRgn, 1);
		}
		RefreshBuffer();
		InvalidateRect(hWnd , NULL , TRUE);
		break;
	case WM_CREATE:
		wDC = GetDC(hWnd);
		whiteBrush = CreateSolidBrush(RGB(255 , 255 , 255));
		hHaikei = CreateCompatibleDC(wDC);
		SelectObject(hHaikei , LoadBitmap(((LPCREATESTRUCT)lParam)->hInstance ,TEXT("BAT")));
		hNum = CreateCompatibleDC(wDC);
		SelectObject(hNum , LoadBitmap(((LPCREATESTRUCT)lParam)->hInstance ,TEXT("NUM")));
		hMenu = CreatePopupMenu();
		hWndBufferBMP = CreateCompatibleBitmap(wDC, WindowSize.cx, WindowSize.cy);
		hWndBufferDC = CreateCompatibleDC(wDC);
		SelectObject(hWndBufferDC, hWndBufferBMP);
		AppendMenu(hMenu, MF_STRING, 1, _T("&About"));
		AppendMenu(hMenu, MF_STRING, 3, _T("&Status..."));
		AppendMenu(hMenu, MF_SEPARATOR, 0, 0);
		AppendMenu(hMenu, MF_STRING, 4, _T("Go to &default position"));
		AppendMenu(hMenu, MF_SEPARATOR, 0, 0);
		AppendMenu(hMenu, MF_STRING, 2, _T("&Exit"));
		hMainRgn = getRgnFromHBITMAP(LoadBitmap(((LPCREATESTRUCT)lParam)->hInstance ,TEXT("MSK")), hWnd);
		hMainRgnAc = getRgnFromHBITMAP(LoadBitmap(((LPCREATESTRUCT)lParam)->hInstance ,TEXT("AMK")), hWnd);
		SetWindowPos(FindWindow(_T("EdStatusPower"), NULL) , HWND_NOTOPMOST , 0 , 0 , 0 , 0 , SWP_NOSIZE | SWP_NOMOVE | SWP_HIDEWINDOW);
		SetTimer(hWnd , 1 , 1000 , NULL);
		SendMessage(hWnd, WM_TIMER, 0, 0);
		break;
	case WM_DESTROY:
		DeleteDC(hHaikei);
		DeleteDC(hNum);
		DestroyMenu(hMenu);
		DeleteObject(whiteBrush);
		DeleteObject(hMainRgn);
		DeleteObject(hMainRgnAc);
		DeleteObject(hWndBufferDC);
		DeleteObject(hWndBufferBMP);
		ReleaseDC(hWnd, wDC);
		SetWindowPos(FindWindow(_T("EdStatusPower"), NULL) , HWND_TOPMOST , 0 , 0 , 0 , 0 , SWP_NOSIZE | SWP_NOMOVE | SWP_SHOWWINDOW);
		PostQuitMessage(0);
		break;
	case WM_MOUSEMOVE:
		if(wParam & MK_LBUTTON)
		{
			if((SHORT)LOWORD(lParam) != g_WindowDragPoint.x || (SHORT)HIWORD(lParam) != g_WindowDragPoint.y)
			{
				if(!g_bWindowMoved && labs((SHORT)LOWORD(lParam) - g_WindowDragPoint.x) < 10 && labs((SHORT)HIWORD(lParam) - g_WindowDragPoint.y) < 10) break;
				g_bWindowMoved = TRUE;
				SIZE Size;
				POINT Corner;
				RECT r;
				GetWindowRect(hWnd, &r);
				Corner.x = r.left + (SHORT)LOWORD(lParam) - g_WindowDragPoint.x;
				Corner.y = r.top + (SHORT)HIWORD(lParam) - g_WindowDragPoint.y;
				Size.cx = r.right - r.left;
				Size.cy = r.bottom - r.top;
				if(Size.cx <= 0 && Size.cy <= 0) break;
				if(Corner.x + Size.cx > GetSystemMetrics(SM_CXSCREEN))
					Corner.x = GetSystemMetrics(SM_CXSCREEN) - Size.cx;
				if(Corner.y + Size.cy > GetSystemMetrics(SM_CYSCREEN))
					Corner.y = GetSystemMetrics(SM_CYSCREEN) - Size.cy;
				if(Corner.x < 0)
					Corner.x = 0;
				if(Corner.y < 0)
					Corner.y = 0;
				SetWindowPos(hWnd, HWND_TOPMOST, Corner.x, Corner.y, 0, 0, SWP_NOSIZE);
			}
		}
		break;
	case WM_LBUTTONDOWN:
		SetCapture(hWnd);
		g_WindowDragPoint.x = (SHORT)LOWORD(lParam);
		g_WindowDragPoint.y = (SHORT)HIWORD(lParam);
		break;
	case WM_LBUTTONUP:
		ReleaseCapture();
		if(g_bWindowMoved)
		{
			g_bWindowMoved = FALSE;
			break;
		}
		static POINT Point;
		Point = g_WindowDragPoint;
		ClientToScreen(hWnd, &Point);
		i = (DWORD)TrackPopupMenu(hMenu, TPM_RETURNCMD | TPM_RIGHTALIGN , Point.x, Point.y, 0, hWnd, NULL);
		if(i == 1){
			MessageBox(NULL, L"Battery Meter for Brain\nVersion 4.0\n(C)2022 TMK", L"About",MB_OK| MB_ICONINFORMATION|MB_TOPMOST|MB_SETFOREGROUND);
		}else if(i == 2){
			PostMessage(hWnd, WM_DESTROY,0, 0);
		}else if(i == 3){
			*tMaru = 0xb0;
			_stprintf(tTemp, _T("BatteryVoltage: %d mV\nBatteryTemperature: %d %sC") ,pSystemPowerStatusEx2.BatteryVoltage , pSystemPowerStatusEx2.BatteryTemperature/10 , tMaru);
			MessageBox(NULL, tTemp, L"Battery Status",MB_OK| MB_ICONINFORMATION|MB_TOPMOST|MB_SETFOREGROUND);
		}else if(i == 4){
			DefaultPos(hWnd);
		}
		break;
	default:
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}
int WinMain(
	HINSTANCE hInstance, 
	HINSTANCE hPrevInstance, 
	LPTSTR lpCmdLine, 
	int nCmdShow
){
	if(FindWindow(_T("BatMtr"), _T(""))) return 0;
	WindowSize.cx = 44;
	WindowSize.cy = 20;
	WNDCLASS wc;
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = 0;
	wc.hCursor = 0;
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);;
	wc.lpszMenuName = 0;
	wc.lpszClassName = _T("BatMtr");
	if(!RegisterClass(&wc)){
		return 1;
	}
	HWND hWnd = CreateWindowEx(
		WS_EX_TOPMOST | WS_EX_NOACTIVATE | WS_EX_TOOLWINDOW,
		_T("BatMtr"), 
		_T(""),
		WS_POPUP ,
		GetSystemMetrics(SM_CXSCREEN) - 4 - WindowSize.cx, 4 , WindowSize.cx, WindowSize.cy,
		0,
		0,
		hInstance,
		0
	);
	if(!hWnd){
		return 1;
	}
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	MSG msg;
	while(GetMessage(&msg, 0, 0, 0) > 0){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return (int)msg.wParam;
}
